#!/usr/bin/env python
# -*- coding: utf-8 -*-

# This file is a part of NoteCalc.
#
# Auteur  : Jonas Fourquier (http://jonas.tuxfamily.org)
# Licence : GNU GPL

if __name__ == "__main__":
    import notecalc
    exit()

import gtk, gtk.glade, gobject,pango
import re, os, ConfigParser, time
#~ from threading import Thread

#localisataion
import i18n

#constantes
import ncalc_cst

#debugging
import pdb
#pdb.set_trace()

from time import strftime
import os


# ******************************************************************************
# Interface graphique
# ******************************************************************************
class gui:

    def __init__(self):
        #constante
        print "currentdirfile = %s"%ncalc_cst.get_currentdir()
        self.gui = gtk.glade.XML(os.path.join(os.environ['NOTECALC_DIR'],'gui','main.glade'))
        dictionnaire_temporaire = {}
        for iteration in dir(self.__class__):
            dictionnaire_temporaire[iteration]= getattr(self,iteration)
        self.gui.signal_autoconnect(dictionnaire_temporaire)

        self.selection = None

        #Config
        #~ self.config = {
            #~ "timethread" : 2 #temps d'attente avant actualistion automatique en seconde
            #~ }

        #gtktree ListCalc
        widgetListCalc = self.gui.get_widget('ListCalc')
        self.list = TreeViewListCalc(widgetListCalc) #gtktree ListCalc
        widgetListCalc.connect('key_press_event', self.on_list_keypress_event)

        #gtktree ListVar
        self.listVar = TreeViewListVar(self.gui.get_widget('ListVar'))
        self.listVar.tmp = []

        #Texte Boite de commande
        self.cmd = self.gui.get_widget("cmd")
        self.cmd.connect('key_press_event', self.on_cmd_keypress_event)
        self.cmd.buffer = self.cmd.get_buffer()
        self.cmd.buffer.connect('changed',self.on_cmd_buffer_changed)

        #self.cmd.connect('move_cursor',self.on_cmd_insert_at_cursor)
        self.cmd.set_wrap_mode(gtk.WRAP_WORD) #à la ligne automatique

        #IdActu
        self.idActu = self.gui.get_widget("idActu")
        self.idActu.set_text("1")
        #Id du calcul global
        self.idCalc = 1

        #precision du resultat
        self.precRes = 2

        #selection courante
        self.currentPath = None

        #valeur selection prec
        (self.oldentry_varname, self.oldentry_linkine) = ('',[])

        #menu bouton insérer
        #~ self.gui.get_widget("InsertLign").set_menu(self.gui.get_widget("menu_InsertLign"))

        #~ self.flagModified = False #drapeau de modification principale

        #menu clique droit
        self.menuClickDroit = self.gui.get_widget("MenuClickDroit")

        #Barre de status
        self.progressBar = self.gui.get_widget("progressbar")
        self.statusBar = self.gui.get_widget("statusbar")
        self.statusBar_contextID = 0


        #Initialisation de variable
        self.positionInStore = None
        #~ self.id2iter = {} #dico contenant idCalc : iter
        self.id2rowref = {}
        self.cmdCursor = {}
        self.cmdCursor['insertLign'] = False #position du curseur
        self.file = None #Nom du fichier courant
        self.dicoIdLine4vars = {} #Id des variables du calculs courant


        self.cancel = []    # liste des dernières modification pour pouvoir annuler [((action,afterid,idCalc,linestore)),...]
        self.restore = []   # liste des dernières annulation pour pouvoir restaurer [idem ci dessus]
                            # avec - action -1 : ligne supprimé
                            #                0 : ligne modifiée
                            #                1 : ligne ajoutée
                            #      - currentid : no d'id courant au moment de l'action
                            #      - afterid   : avant quel id cette action à eu lieu (None pour action 0)
                            #      - id        : de la ligne sur laquelle il y a eu action
                            #      - linestore : ancien contenu de la ligne (None pour action 1)


        ### CLASSE
        import traiter
        self.traiter = traiter.traiter()
        import paramProjet
        self.paramProjet = paramProjet.paramProjet()

        #lecture fichier de config
        self.config = ConfigParser.ConfigParser()
        self.config.read(os.path.join(os.environ['NOTECALC_USERDIR'],'config.ini'))
        #Ajout des nouvelle entrée si il y en a
        newConfig = ConfigParser.ConfigParser()
        newConfig.read(os.path.join(os.environ['NOTECALC_DIR'],'config.ini'))
        for section in newConfig.sections() :
            if not self.config.has_section(section) :
                self.config.add_section(section)
            for option in newConfig.options(section) :
                if not self.config.has_option(section, option) :
                    self.config.set(section, option, newConfig.get(section, option))
                    print 'Section "%s" option "%s" ajouter au fichier de config'%(section, option)


        self.nextTpsSave = time.time() + self.config.getint('loadsave','autosave')

        #desctive sauvé
        self.contentChange = False
        self.btSave_sensitive(True)


        def autosave(autosavetps):
            import saveLoad
            self.change_message("Sauvegarde automatique ...")
            self.progressBarStat('start_pulse')
            saveLoad.save(self.paramProjet.get(),self.list.store,self.file,True)
            self.progressBarStat('stop_pulse')
            return True

        autosavetps = self.config.getint('loadsave','autosave')
        self.timeout_autosave = gobject.timeout_add (autosavetps*1000, autosave, self)

        #Ajout de boutons dans la gui pas les plugins
        from imp import load_source
        for dirplug in os.listdir(os.path.join(os.environ['NOTECALC_DIR'],"plugins")):
            try :
                plug_add2gui = load_source('add2gui',os.path.join(os.environ['NOTECALC_DIR'],"plugins",dirplug,"add2gui.py"))
            except :
                pass
            else :
                self = plug_add2gui.add(self)
            #~



        #Boite d'astuce
        import astuces
        astuces.astuces(True)



    def change_message(self,text,tps=5000):
        print 'message : %s'%text
        if tps == 0 :
            '''message permanent'''
            self.statusBar.pop(self.statusBar_contextID)        #supprime le précédent message
            self.statusBar_contextID += 1
            self.statusBar.push(self.statusBar_contextID, text) #Ajout le nouveau
        else :
            '''message a duré de vie déterminée'''
            self.statusBar.push(2, text)
            gobject.timeout_add (tps, self.statusBar.pop,2);
            self.statusBar_contextID += 1
        return

    def progressBarStat(self,etat) :
        '''Fait bouger le barre de progression'''

        def startpulse():
            self.progressBar.pulse()
            return True

        if etat == "start_pulse" :
            #~ self.progressBar.show()
            self.progressBar.pulse()
            self.progressBar.pulsed = gobject.timeout_add (100, startpulse)
        elif etat == "stop_pulse" :
            #~ self.progressBar.hide()
            gobject.source_remove(self.progressBar.pulsed)
            self.progressBar.set_fraction(0.0)


    def btSave_sensitive(self,sensitive):
        '''Desactive les fonction de sauvegarde si aucune modification'''
        #~ pdb.set_trace()
        if self.contentChange != sensitive :
            self.gui.get_widget('Save').set_sensitive(sensitive)
            self.contentChange = sensitive



    def quitter(self):
        'Fonction appeler lors de la sortie du programme'
        # Eregistrement du nom du dernier fichier ouvert
        #~ self.config.set('global', 'lastfile', self.file)
        #~ self.config.write(open(os.path.join(os.environ['NOTECALC_DIR'],'config.ini'),'w'))
        if self.contentChange :
            dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING, # type
                    gtk.BUTTONS_OK_CANCEL, # boutons
                    "Êtes vous sûr de vouloir quitter sans enregister les modifications ?"#Message
                )

            if dialog.run() != gtk.RESPONSE_OK :
                dialog.destroy()
                return True

        #ecriure fichier config
        self.config.write(open(os.path.join(os.environ['NOTECALC_USERDIR'],'config.ini'),'w'))

        print "Sortie du programme, suppression du dossier temporaire %s"%os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir())
        gobject.source_remove(self.timeout_autosave)
        #~ for file in os.listdir(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures')):
            #~ if os.path.isfile(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',file)) :
                #~ os.unlink(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',file))
        #~ os.rmdir(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures'))
        #~ for file in os.listdir(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir())):
            #~ if os.path.isfile(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),file)) :
                #~ os.unlink(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),file))
        #~ os.rmdir(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir()))
        gtk.main_quit()



    #####################################
    # - Signaux Menu / Barre d'outils - #
    #####################################

    ### BARRE DE MENU ###
    #fichier
    def on_New_activate(self,event):
        print '*** newdoc ***'

        if (len(self.list.store) != 0):
            boitedialogue = gtk.MessageDialog(
                None, #parent
                gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                gtk.MESSAGE_WARNING, # type
                gtk.BUTTONS_OK_CANCEL, # boutons
                _("Les modifications du projet en cours seront perdues."))#Message
            if (boitedialogue.run() != gtk.RESPONSE_OK):
                print ' -> cancel'
                boitedialogue.destroy()
                return False
            else :
                boitedialogue.destroy()
        print ' -> open'
        self.list.store.clear()
        self.idCalc = 1
        self.idActu.set_text("1")
        self.file = None
        self.on_paramProjet_activate()

        self.btSave_sensitive(True)



    def on_bt_tb_open_clicked(self,event):
        '''Bt ouvrir de la barre d'outils'''
        self.on_open_activate(event)

    def on_open_activate(self,event):
        '''Ouvrir via le menu'''
        if (len(self.list.store) != 0):
            #Boite de confiramtion d'effacement de l'ancien calcul
            boitedialogue = gtk.MessageDialog(
                None, #parent
                gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                gtk.MESSAGE_WARNING, # type
                gtk.BUTTONS_OK_CANCEL, # boutons
                _("Les modifications du projet en cours seront perdues."))#Message

            if (boitedialogue.run() != gtk.RESPONSE_OK):
                boitedialogue.destroy()
                return
            else :
                print ' -> open'
                boitedialogue.destroy()
        self.list.store.clear()

        import saveLoad
        load = saveLoad.load()
        (file,paramProjet,storeCalc) = load.start()
        if (file) :
            self.progressBarStat('start_pulse')

        listID = []
        self.file = file


        areLineNotCalculed = True
        while areLineNotCalculed == True:
            areLineNotCalculed = False
            for linestore in storeCalc:

                (idCalc, nameVar, entry, render, aff, prec, res, unit, linkCalc, dicoIdsVars, comment, type) = linestore

                if type == 'img':
                    '''si c'est une image'''
                    if aff['pixbuf'] == None:
                        '''Si pas de pixbuf, le charger'''
                        import image
                        wimg = image.image(self.idCalc,aff,False)#name dico_img gui X Y
                        iter = self.list.store.append((
                                idCalc,             #  0 # id
                                '',                 #  1 # namevar
                                'img',              #  2 # entry
                                wimg.get_str4render(),#3 # render
                                wimg.get_dicoimg(), #  4 # aff
                                0,                  #  5 # prec
                                0.0,                #  6 # res
                                '',                 #  7 # unit
                                [],                 #  8 # linkline
                                {},                 #  9 # dicovar
                                wimg.name,          # 10 # commentaire (nom image)
                                'img'               # 11 # type
                            ))
                        #~ pdb.set_trace()
                elif res == None:
                    '''Si il n'y a pas de resultat'''
                    #On recherche la variable

                    canIcalcul = False  # puis-je calculer cette ligne ?
                    var4calc = []       # valeur des varaible nécéssaire au calcul
                    if len(dicoIdsVars) == 0:
                        '''il n'y a pas de variable → calcul'''
                        canIcalcul = True
                    else:
                        # regardons si les variables ont déjà été calculée
                        for (nameVar,idLineVar) in dicoIdsVars.items() :
                            for linestorebis in self.list.store :
                                '''scan les lignes du store pour voir si l'id s'y trouve déjà et s'il est calculé'''
                                canIcalcul = False
                                if idLineVar == linestorebis[0]:
                                    if linestorebis[6] != None :
                                        canIcalcul = True
                                        var4calc.append((nameVar,linestorebis[6],linestorebis[5]))
                                    break #on a trouvé l'id de la ligne, sortie de la boucle : for linestorebis in self.listVar.store
                            if not canIcalcul :
                                break #sortie de la boucle "for idLineVar in dicoIdsVars.values()" car ça sert a rien ce continuer


                    if canIcalcul:
                        '''on calcul'''
                        #~ pdb.set_trace()
                        self.traiter.new(entry,idCalc,var4calc,True)
                        render = self.traiter.render()
                        res = self.traiter.resultat()
                        unit = self.traiter.get_unit()
                        comm = self.traiter.get_commentaire()
                        nameVar = self.traiter.get_nameVar()

                        #remplire la treeview sans la calculée
                        self.debugType((idCalc, nameVar, entry, render, aff, prec, res, unit, linkCalc, dicoIdsVars, comment, type))
                        iter = self.list.store.append((idCalc, nameVar, entry, render, aff, prec, res, unit, linkCalc, dicoIdsVars, comment, type))

                        #Stock l'iter de l'id
                        #~ self.id2iter[idCalc] = iter

                        #Indique au autre ligne liée qu'elles le sont
                        for linkid in dicoIdsVars.values():
                            self.list.store[self.get_iterWithId(linkid)][8].append(idCalc)


                    else :
                        #~ pdb.set_trace()
                        areLineNotCalculed = True
                        break

                #Trouver l'id max (pour l'id de la prochaine ligne)
                if self.idCalc <= idCalc :
                    self.idCalc = idCalc +1



        self.paramProjet.set(paramProjet) #initialise les paramêtre de projet
        self.idActu.set_text(str(self.idCalc)) # met a jour la gui de l'id actu

        self.progressBarStat('stop_pulse')

        self.btSave_sensitive(False)




    def on_save_activate(self,event):
        print '*** save ****'
        import saveLoad
        #~ pdb.set_trace()

        save = saveLoad.save(self.paramProjet.get(),self.list.store,self.file,False) #info, calc, file=None, speedSave=False, saveAs = False
        self.change_message(_('Sauvegarde effectuée dans %s')%(self.file))

        self.btSave_sensitive(False)

        #~ save.start(self.paramProjet.get(),self.list.store,self.file,False)


    def on_saveAs_activate(self,event):
        print '*** saveAs ***'
        import saveLoad
        save = saveLoad.save(self.paramProjet.get(),self.list.store,self.file,False,True) #info, calc,  [file,] [speedSave,] [saveAs]
        self.btSave_sensitive(False)
        #~ self.file = save.start(self.paramProjet.get(),self.list.store,self.file,False) #Ne retourn pour l'instant pas le nom du fichier, a venir

    def append_cancel(self,action,afterid,linestore):
        '''pile d'annulation'''
        print "idCalc %s"%self.idCalc
        self.cancel.append((action,afterid,self.idCalc,linestore))
        self.gui.get_widget('restore').set_sensitive(False)


    def on_cancel_clicked(self,event,from_restore=False):
        '''Bouton annuller'''
        print '*** Cancel ***'
        if ncalc_cst.debug :
            print 'liste annulation :'
            for line in self.cancel :
                print ' - %s'%line[3][2]

        #~ self.gui.get_widget('ListCalc').set_model(None)
        try :   (action,afterid,self.idCalc,linestore) = self.cancel.pop()
        except: return False

        self.idActu.set_text(str(self.idCalc))

        #~ pdb.set_trace()

        if action == -1 :
            '''la ligne avait été supprimée → ajout'''
            if (linestore[11] == 'img'):
                '''chargement de l'ancienne image'''
                import image
                wimg = image.image(self.idCalc,False,linestore[2],False)
                linestore = (linestore[0], linestore[1], linestore[2], linestore[3],\
                        wimg.get_pbthumb(), linestore[5], linestore[6], linestore[7],\
                        linestore[8], linestore[9], linestore[10], linestore[11])
                old_linestore = None

            if afterid :
                iter = self.list.store.insert_before(self.get_iterWithId(afterid),linestore)
            else :
                iter = self.list.store.append(linestore)

        elif action == 0 :
            '''la ligne avait été modifiée → restauration'''
            iter = self.get_iterWithId(linestore[0])
            old_linestore = self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10,11)
            if (linestore[11] == 'img'):
                '''chargement de l'ancienne image'''
                import image
                wimg = image.image(self.idCalc,False,linestore[2],False) #nom, pb, lineoption, gui
                linestore = (linestore[0], linestore[1], linestore[2], linestore[3],\
                        wimg.get_pbthumb(), linestore[5], linestore[6], linestore[7],\
                        linestore[8], linestore[9], linestore[10], linestore[11])

            self.list.store[iter] = linestore

        elif action == 1 :
            '''la ligne avait été ajoutée → suppression'''
            iter = self.get_iterWithId(linestore[0])
            old_linestore = self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10,11)
            self.list.store.remove(iter)


        self.restore.append ((action,afterid,self.idCalc,old_linestore))#Ajout de l'annualtion dans la liste des restauration pour pouvoir restauré l'anullation
        self.gui.get_widget('restore').set_sensitive(True)              #Active le bouton



    def on_restore_clicked(self,event):
        '''Bouton restorer'''
        print '***restore***'

        if len(self.restore) > 0 :
            (action,afterid,self.idCalc,linestore) = self.restore.pop()

        if len(self.restore) == 0 :
            self.gui.get_widget('restore').set_sensitive(False)

        if action == -1 :
            '''la ligne avait été ajouter pas la commande annulé → suppression'''
            iter = self.get_iterWithId(linestore[0])
            old_linestore = self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10,11)
            self.list.store.remove(iter)
        elif action == 0 :
            '''la ligne avait été restauré via annuation → rerestauration'''
            iter = self.get_iterWithId(linestore[0])
            old_linestore = self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10,11)
            if (linestore[11] == 'img'):
                '''chargement de l'ancienne image'''
                import image
                wimg = image.image(self.idCalc,False,linestore[2],False) #nom, pb, lineoption, gui
                pdb.set_trace()
                linestore = (linestore[0], linestore[1], linestore[2], linestore[3],\
                        wimg.get_pbthumb(), linestore[5], linestore[6], linestore[7],\
                        linestore[8], linestore[9], linestore[10], linestore[11])
            self.list.store[iter] = linestore
        elif action == 1 :
            '''la ligne avait été supprimé par la commande annulé → restauration'''
            if (linestore[11] == 'img'):
                '''chargement de l'ancienne image'''
                import image
                wimg = image.image(self.idCalc,False,linestore[2],False)
                llinestore = (linestore[0], linestore[1], linestore[2], linestore[3],\
                        wimg.get_pbthumb(), linestore[5], linestore[6], linestore[7],\
                        linestore[8], linestore[9], linestore[10], linestore[11])

            if afterid :
                iter = self.list.store.insert_before(self.get_iterWithId(idafter),linestore)
            else :
                iter = self.list.store.append(linestore)

            old_linestore = linestore

        #balance la ligne dans le tableau d'annulation, True pour dire qu'on vient de de fct restaure
        self.cancel.append((action,afterid,self.idCalc,old_linestore))

        if action == 1 :
            self.idCalc += 1
        self.idActu.set_text(str(self.idCalc))

        self.btSave_sensitive(True)



    def on_gestion_plugins_activate(self,event):
        print '*** gestionnaire plugins ****'
        import plugins
        plugins = plugins.plugins(self.paramProjet.get(), self.list.store)
        plugins.gui()

    def run_a_plugin(self,plugin):
        import plugins
        plugins = plugins.plugins(self.paramProjet.get(), self.list.store)
        plugins.run(plugin)


    #Editer
    def on_paramProjet_activate(self,event=None):
        '''Ouverture de la boite de dialogue des paramètre du projet'''
        print '*** open paramProjet ***'
        self.paramProjet.open()

        self.btSave_sensitive(True)


    #Afficher
    def on_aff_colonnes_activate(self,event):
        '''Liste de case a cocher pour l'affichage/masquage de collone'''
        boitedialogue = gtk.Dialog(_("Affichage colonnes"),#title
                None,#parent
                gtk.DIALOG_DESTROY_WITH_PARENT , #flag
                (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))#button



        checkEntry = (
            (_('Id de la ligne'         ),  'id'),
            (_('Rendu de la ligne'      ),  'render'),
            (_('Signe égale'            ),  'egal'),
            (_('Résultat'               ),  'result'),
            (_('Commentaire'            ),  'comment'),
            (_('Saise'                  ),  'entry'),
            (_('Liste des lignes liées' ),  'variables')
            )

        checkButton = {}
        for (label,name) in checkEntry:
                checkButton[name] = gtk.CheckButton(label)
                try : checkButton[name].set_active(self.config.getboolean('aff_colonne', name))
                except : checkButton[name].set_active(True)
                boitedialogue.vbox.pack_start(checkButton[name], True, True, 0)
                checkButton[name].show()

        line = gtk.HSeparator()
        boitedialogue.vbox.pack_start(line, True, True, 0)
        line.show()

        etiquette = gtk.Label(_("Note : un redémarage est nécessaire pour que les changements prennent effect."))
        etiquette.set_line_wrap(True)
        boitedialogue.vbox.pack_start(etiquette, True, True, 0)
        etiquette.show()

        boitedialogue.show()

        if (boitedialogue.run() == gtk.RESPONSE_OK):
            for (label, name) in checkEntry:
                self.config.set('aff_colonne', name, checkButton[name].get_active())


        boitedialogue.destroy()


    def on_EditLine_clicked(self,event):
        '''editer une ligne via le bouton'''
        try:    self.on_ListCalc_row_activated(self.list.store,self.currentPath[0][0],None)
        except: self.change_message(_('Aucune ligne séléctionnée, édition impossible'))

    def on_astuces_activate(self,event=None):
        import astuces
        astuces.astuces()

    def on_about_activate(self,event):
        print '*** aboutdialog ***'
        import about
        about = about.about()
        about.open()


    # ------

    def on_InsertLign_clicked(self,event):
        print '*** insert ligne ***'
        #pdb.set_trace()
        #~ self.idCalc += 1
        lineStore = (
                    self.idCalc,        #  0 # int # id
                    None,               #  1 #
                    '',                 #  2 # str
                    '',                 #  3 # str
                    (
                        self.gui.get_widget('toggleNum').get_active(),
                        self.gui.get_widget('toggleAlgebre').get_active(),
                        0 #self.gui.get_widget('toggleLaTeX').get_active()
                    ),                  #  4 # object
                    0,                  #  5 # int
                    0,                  # float
                    '',                 # str
                    [],                 # object
                    {},
                    '',
                    'empty')            # str
        if self.currentPath :
            self.currentPath
            print ' -> before %s'%(self.currentPath[0][0])
            #pdb.set_trace()
            iter = self.list.store.insert(self.currentPath[0][0],lineStore)
            self.positionInStore = self.currentPath[0][0]
        else :
            print ' -> no row selected -> add to end'
            iter = self.list.store.append(lineStore)
            self.positionInStore = None

        #ajout au tableau d'annulation
        if iter :  afterid = self.list.store.get_value(self.list.store.iter_next(iter),0)
        else :     afterid = None
        self.append_cancel(+1,afterid,self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10))
        #~ self.cancel.append((+1,afterid,self.idCalc,self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10)))

        print "self.positionInStore : %s"% self.positionInStore
        self.btSave_sensitive(True)

        self.idCalc += 1
        self.idActu.set_text(str(self.idCalc))


    def on_insertLign_activate(self,event):
        '''insérer un ligne de calcul via menu du bouotn ajouter'''
        self.on_InsertLign_clicked(self)

    def on_insertImg_clicked(self,event):
        '''insérer un image via menu du bouton ajouter'''
        import image
        print "attendre destruction enfant"
        wimg = image.image(self.idCalc)
        print "enfant detruit"
        #~ pdb.set_trace()
        if wimg.changed :
            print "%s chemain %s"%(wimg.name,wimg.tmppath)
            #~ pdb.set_trace()

            rowstore=(
                    self.idCalc,        #  0 # id
                    '',                 #  1 # namevar
                    'img',              #  2 # entry
                    wimg.get_str4render(),   # render
                    wimg.get_dicoimg(), #  4 # aff
                    0,                  #prec
                    0.0,                #res
                    '',                 #unit
                    [],                 #linkline
                    {},                 #dicovar
                    wimg.name,          #commentaire (nom image)
                    'img'               #type
                )
            self.debugType(rowstore)
            iter = self.list.store.append(rowstore)

            # Ajout de l'entreé dans le tableau s'annulation
            try :   idafter = self.liste.get_value(self.liste.iter_next(iter),0)
            except: idafter = None
            self.append_cancel(+1, idafter, None)
            #~ self.cancel.append((1, idafter, self.idCalc, None)) # 1 indique que la ligne a été ajoutée

            #incrémentation de l'id
            self.idCalc += 1
            self.idActu.set_text(str(self.idCalc))

            self.btSave_sensitive(True)





    def on_SupprLign_clicked(self,event=None):
        '''Boutons de suppression d'une ligne'''
        print '*** del Line(s) ***'

        for path in self.currentPath :
            #~ pdb.set_trace()
            try :   idafter = self.list.store.get_value(self.list.store.iter_next(self.list.store.get_iter(path)),0)
            except: idafter = None
            #Si d'autre cellule sont liée avertir utilisateur
            if self.list.store[path][8]:
                '''D'autres lignes dépendent de celle-ci'''
                msg=[]
                for line in self.list.store[iter][8]:
                    msg.append(str(line))
                boitedialogue = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING,            # type
                    gtk.BUTTONS_OK_CANCEL,          # boutons
                    _("La/les ligne(s) %(linesNeedLine)s ne pouront plus être calculée(s) si %(deleteLine)s est supprimé.\n\nSouaitez vous réellement supprimé cette ligne ?"%{'linesNeedLine': ", ".join(msg), 'deleteLine' : self.list.store[iter][0]}))#Message
                if (boitedialogue.run() == gtk.RESPONSE_OK):
                    old_row_store = self.list.store.get(self.list.store.get_iter(path),0,1,2,3,4,5,6,7,8,9,10,11)
                    self.list.store.remove(self.list.store.get_iter(path))
                boitedialogue.destroy()
            else:
                '''Pas de liaison, suppression direct'''
                old_row_store = self.list.store.get(self.list.store.get_iter(path),0,1,2,3,4,5,6,7,8,9,10,11)
                self.list.store.remove(self.list.store.get_iter(path))

            # Ajout de l'entreé dans le tableau d'annulation


            self.append_cancel(-1, idafter, old_row_store)
            #~ self.cancel.append((-1,idafter,self.idCalc,old_row_store)) #-1 indique que la ligne a été supprimée

        self.btSave_sensitive(True)


    #Quitter
    def on_exit(self, source=None, event=None):
        self.quitter()
    def on_quitter1_activate(self,event):
        self.quitter()
    #~ def on_NoteCalcMain_destroy(self,event):
        #~ self.quitter()
    def on_NoteCalcMain_delete_event(self,event,data):
        print '***deleteevent***'
        return self.quitter()


    #Bouton affichage
    def aftertoggled(self,aff):
        for path in self.currentPath:
            self.list.store[path][4] = aff
            self.majRow(self.list.store.get_iter(path))

        self.btSave_sensitive(True)

    def on_toggleAlgebre_toggled(self,object):
        (algebre,num,latex) = self.list.store[self.currentPath[0]][4]
        if not num :
            num = 1
            self.gui.get_widget('toggleNum').set_active(1)
        self.aftertoggled((object.get_active(),num,latex))
    def on_toggleNum_toggled(self,object):
        (algebre,num,latex) = self.list.store[self.currentPath[0]][4]
        if not algebre :
            algebre = 1
            self.gui.get_widget('toggleAlgebre').set_active(1)
        self.aftertoggled((algebre,object.get_active(),latex))
    def on_toggleLaTeX_toggled(self,object):
        (algebre,num,latex) = self.list.store[self.currentPath[0]][4]
        self.aftertoggled((algebre,num,object.get_active()))


    def on_precRes_populate_popup(self,object):
        object.set_use_markup(True)


    def on_precDown_clicked (self,object):
        '''diminuer la précision'''
        self.precRes = self.precRes - 1
        #~ self.gui.get_widget('precRes').set_text("10<sup>%s</sup>"%self.precRes)   #maj de l'afficheur
        #~ self.gui.get_widget('precRes').set_use_markup(True)
        #~ self.gui.get_widget('precRes').set_property('markup',"10<sup>%s</sup>"%self.precRes)   #maj de l'afficheur
        for path in self.currentPath:
             self.list.store[path][5] = self.precRes
        self.btSave_sensitive(True)


    def on_precUp_clicked (self,object):
        '''diminuer la précision'''
        self.precRes = self.precRes + 1
        #~ self.gui.get_widget('precRes').set_text("10<sup>%s</sup>"%self.precRes)   #maj de l'afficheur
        #~ self.gui.get_widget('precRes').set_use_markup(True)
        for path in self.currentPath:
             self.list.store[path][5] = self.precRes
        self.btSave_sensitive(True)

    def on_precRes_changed(self,SpinButton):
        '''position de la virgule'''
        #~ print widget
        precRes = int(SpinButton.get_value())
        for path in self.currentPath:
             self.list.store[path][5] = precRes

        self.btSave_sensitive(True)




    ################################
    # - Signaux liste de calculs - #
    ################################

    #Double clique sur une ligne
    def on_ListCalc_row_activated(self,treeview,position,treeviewColumn):
        #~ global DicoCalculs
        print 'ligne %s selectionnée' % position

        old_row_store = self.list.store.get(self.list.store.get_iter(position[0]),0,1,2,3,4,5,6,7,8,9,10,11)
        (self.oldentry_varname, self.oldentry_linkine) = self.list.store.get(self.list.store.get_iter(position[0]),1,8)

        if (old_row_store[11] == 'img'):
            '''Ouvre la fenêtre d'édition d'image'''
            import image
            print "attendre destruction enfant"
            wimg = image.image(self.idCalc,self.list.store[position][4])
                                #name='tmp', dico_img={}, gui=True, tmX=320, tmY=240
            print "enfant detruit"
            #~ pdb.set_trace()
            if wimg.changed:
                print "%s chemin %s"%(wimg.name,wimg.tmppath)

                self.change_message(_('Modifier la figure'))
                #~ pdb.set_trace()
                rowstore=(
                        old_row_store[0],   #  0 # id
                        '',                 #  1 # namevar
                        'img',              #  2 # entry
                        wimg.get_str4render(),   # render
                        wimg.get_dicoimg(), #  4 # aff
                        0,                  #prec
                        0.,                 #res
                        '',                 #unit
                        [],                 #linkline
                        {},                 #dicovar
                        wimg.name,          #commentaire (nom image)
                        'img'
                    )
                #~ self.debugType(rowstore)
                self.list.store[position] = rowstore

                try :   idafter = self.list.store[self.positionInStore+1][0]
                except: idafter = None
                self.append_cancel(0, idafter, old_row_store)
                #~ self.cancel.append((0,idafter,self.idCalc,old_row_store)) # O indique que la ligne a été modifier
        else:
            #~ self.statusBar.push(1,'Modification du calcul %s.' % self.list.store[position][0])
            self.idActu.set_text(str(self.list.store[position][0]))
            self.cmd.buffer.set_text(self.list.store[position][2])
            self.dicoIdLine4vars = self.list.store[position][9] # récupère dans store calc les id ou chercher les variables
            self.positionInStore = position
            self.change_message(_('Modifier la ligne %s'%self.idActu.get_text()))
            self.on_cmd_actualise(True)
            self.cmd.grab_focus()

    #Changement de la sélection
    def on_ListCalc_cursor_changed(self,object):
        '''changement curseur → clique sur un élément de la liste'''
        self.selection = object.get_selection()
        (store, self.currentPath) = self.selection.get_selected_rows()  #cherche le(s) élément activé
        self.affRow(store[self.currentPath[0]])
        id = store[self.currentPath[0]][0]

        if store[self.currentPath[0]][11] in ('calc','var','calcvar') :
            '''type qui a un reslutat, insertion du no de ligne dans le calcul courant'''
            self.change_message('insérer le resultat de la ligne %s' %id, 2)
            #Position correctement les boutons de rendu ('alg,Num,Tex')
            (algebre,num,latex) = store[self.currentPath[0]][4]
            self.gui.get_widget('toggleAlgebre').set_active(algebre)
            self.gui.get_widget('toggleNum').set_active(num)
            #~ self.gui.get_widget('precRes').set_text('10<sup>%s</sup>'%store[self.currentPath[0]][5])
            #~ self.gui.get_widget('precRes').set_use_markup(True)

            #~ self.gui.get_widget('toggleLaTeX').set_active(latex)

            if self.cmdOnEdit:
                #pdb.set_trace()
                #self.cmd.set_editable(True)
                if self.cmd.buffer.get_modified():
                    '''Si c'est la 1ère fois qu'on appuis sur un ligne depuis la dernière édition
                    de la commande, stock dans 2 variables la bout de formule qui se trouve avant
                    et celui qui se trouve après le curseur.'''
                    iterdebut, iterfin = self.cmd.buffer.get_bounds()
                    try :
                        iterinsert, iterselection_bound = self.cmd.buffer.get_selection_bounds()
                    except :
                        iterinsert = iterselection_bound = self.cmd.buffer.get_iter_at_mark(self.cmd.buffer.get_insert())

                    itercursor = self.cmd.buffer.get_iter_at_mark(self.cmd.buffer.get_insert())
                    self.cmdCursor['cmdleft'] = self.cmd.buffer.get_text(iterdebut, iterinsert)
                    self.cmdCursor['cmdright'] = self.cmd.buffer.get_text(iterselection_bound, iterfin)
                #Active le drapeur d'insertion de ligne dans la cmd
                self.cmdCursor['insertLign'] = True
                #Inserer l'id de la ligne
                if (store[self.currentPath[0]][11]) in ('var','calcvar') :
                    self.cmd.buffer.set_text(''.join([self.cmdCursor['cmdleft'],store[self.currentPath[0]][1],self.cmdCursor['cmdright']]))
                else :
                    self.cmd.buffer.set_text(''.join([self.cmdCursor['cmdleft'],'$',str(id),self.cmdCursor['cmdright']]))
                #self.cmd.buffer.insert(self.cmdCursor['iterDebut'], '$%s'%id)
                #Actualisé la zone de saisie (True indique qu'il faut chercher les variables)
                self.on_cmd_actualise(True)

                self.cmd.grab_focus() #Devrait (ça marche pas) donner le focus a la ligne de commande

                self.cmd.buffer.set_modified(False) #baisse le drapeaux de modification de cmd
            else :
                self.change_message(_('Pas de resultat, insertion dans un autre calcul impossible'), 2)


    def on_list_keypress_event(self,widget,event):
        '''Touche pressé quand on se trouve dans l'arbre des calc'''
        print 'on_list_keypress_event'
        #pdb.set_trace()
        #self.cmd.buffer.insert_at_cursor(str(event)) #plein de problème pas là
        if event.keyval == gtk.keysyms.Delete :
            self.on_SupprLign_clicked()
        else :
            self.cmd.grab_focus()


    #######################################
    # - Signaux de la liste de variable - #
    #######################################
    def on_ListVar_button_press_event(self,object,event):
        #self.event.time = event.time
        print '***on_ListVar_button_press_event***'
        self.cmd.grab_focus()


    def on_ListVar_cursor_changed(self,object):
        '''Quand on clique dans le treeview des varaibles'''
        print '***on_ListVar_cursor_changed***'

        selection = object.get_selection()
        (treestore, path) = selection.get_selected_rows()
        linestore = treestore[path[0]]

        iterParent = treestore.iter_parent(treestore.get_iter(path[0]))
        if iterParent: #si c'est un enfant, alors l'introduit dans le parent et on informe listcalc
            treestore.set(iterParent, 0,linestore[0] , 2,linestore[2] , 3,linestore[3] , 4,linestore[4])
            #~ self.list.store.set_value(self.id2iter[self.idActu],9,linestore[0])
            print "stockage de l'id4var temporaire"
            self.dicoIdLine4vars[linestore[1]] = linestore[0] #stock la variable dans un dico tmps pour si l'id a utilisé a été spéciier lors de la frappe


    def on_ListCalc_focus_out_event(self,object,event):
        '''Focus endhors de la list des calcs → deselection'''
        print event
        #FIXME event ne fonctionne pas le but et de desectionner quand on clique a coté mais pas quand la systeme donne ma focus, peut etre redonner le focus que $ligne est insérer
        if event.type == gtk.gdk.BUTTON_PRESS :
            self.selection.unselect_all()


    def on_SelectNewValueForVar(self,widget, event,path):
        '''Fonction appellée dans "on_ListVar_button_press_event" lors d'un clique dans le menu clicj de choix des variable'''
        print "on_SelectNewValueForVar(widget=%s,event=%s,path=%s)" %(widget,event,path)
        print self.listVar.store[path[1]][2]
        self.listVar.store[path[1]][2] = event


    ### Signaux dans popup selVar ###############################################

    #Zone de saisie de definition d'une valeur de variable
    def on_valVar_changed(self,entry):
        print "on_valVar_changed"
        print self.listVar
        treeview = self.listVar.list
        (modele,path) = treeview.get_selection().get_selected_rows()
        print path[0]
        self.listVar.store[path[0]][2] = entry.get_text()

    def on_closeDefVar_clicked(self,truc):
        self.WinDefVar.hide()
    def on_winDefVar_delete_event(self, widget, evenement, donnees=None):
        print "signal delete"
        self.WinDefVar.hide()
        return True #pour ne pas détruire la fenètre



    ##################################################
    # - Signaux de la zone de saisie des commandes - #
    ##################################################

    def on_cmd_focus_in_event(self,object,event):
        '''Méthodes lancé au focus IN de cmd'''
        self.change_message('Tapez votre saisie')
        self.cmdOnEdit = True #variable indiquand que le zone de saisie est en cours d'édition


    def on_cmd_focus_out_event(self,object,event):
        '''Méthodes lancé au focus OUT de cmd'''
        #self.cmdOnEdit = None
        self.statusBar.pop(1)


    def on_cmd_actualise(self, check_var = True): #checkvar a true au lieu de false pour check chaque fois si il y a des variables
        '''Actualisations de la commande'''
        iterdebut,iterfin = self.cmd.buffer.get_bounds()
        entry = self.cmd.buffer.get_text(iterdebut,iterfin,True)

        #pdb.set_trace()

        if entry[-1:] == '$':
            check_var = True

        if entry[-1:].isalpha() | check_var:
            '''Si la dernière lettre est une lettre OU qu'on arrive
            d'une actualisation de cellules'''
            print "lancement de la recherche de variable"
            # Cherche les variables en suppriment les espace de la chaine
            #listVar = self.traiter.get_namesVars(str)
            #~ self.traiter.new(entry,id)
            namesVars = self.traiter.get_namesVars(entry.strip())
            #~ pdb.set_trace()
            print "nom de variable de ligne courante : %s"%namesVars
            #~ pdb.set_trace()

            self.listVar.store.clear()

            for nameVar in namesVars :
                alreadyExist = False
                nameVar = nameVar.strip()
                for linestore in self.listVar.store : #scan de la liste des variable courante pour voir si elle s'y trouve déjà
                    if nameVar == linestore[1]:
                        alreadyExist = True
                        break;

                if not alreadyExist: #si le variable ne se trouve pas déja dans le liste
                    list4storeVar = []
                    #~ pdb.set_trace()
                    if nameVar[0] == '$':
                        '''recherche du resultat en fonction de l'id (colone 0)'''
                        linestore = self.list.store[self.get_iterWithId(int(nameVar[1:]))] #récupère l'iter de la ligne
                        list4storeVar.append (( #ajout au stor calc
                                        linestore[0],   # int # id ou il faut chercher le resultat (0 : valeur definie manuellement)
                                        nameVar,        # str # Nom de la variable à afficher
                                        linestore[6],   # flt # valeur à afficher et utilisé si idCalc = 0
                                        linestore[5],   # int # Précition
                                        linestore[7],   # str # Unitée
                                        linestore[10])) # str # Commentaire
                        alreadyExist = True
                    else :
                        '''on cherche dans le colonne 1 toute les ligne avec ce nom de variable'''
                        for linestore in self.list.store :
                            print "%s ?=? %s"%(nameVar, linestore[1])
                            if linestore[1]:
                                if nameVar == linestore[1].strip(): #regarde dans la colonne variable
                                    print "ok"
                                    list4storeVar.append (( #ajout au stor calc
                                            linestore[0],   # int # id ou il faut chercher le resultat (0 : valeur definie manuellement)
                                            linestore[1],   # str # Nom de la variable à afficher
                                            linestore[6],   # flt # valeur à afficher et utilisé si idCalc = 0
                                            linestore[5],   # int # Précition
                                            linestore[7],   # str # Unitée
                                            linestore[10])) # str # Commentaire
                                    alreadyExist = True
                    #~ pdb.set_trace()
                    print "dicoIdLine4vars %s"%self.dicoIdLine4vars
                    if alreadyExist:
                        if nameVar in self.dicoIdLine4vars.keys():
                            #comme parent des variables sélétionne le précédement utilisé
                            parentIter = self.listVar.store.append(None,self.list.store.get(self.get_iterWithId(self.dicoIdLine4vars[nameVar]),0,1,6,5,7,10))
                        else :
                            # sinon prend le dernier introduit dans store calc
                            parentIter = self.listVar.store.append(None,list4storeVar[-1]) #Affiche dans le ligne parente la dernière valeur de la variable
                        if len(list4storeVar) > 1:
                            for linestoreVar in list4storeVar: #Ajouter comme enfan tout les valeur possible
                                self.listVar.store.append(parentIter,linestoreVar)

                    else : #si la variable n'a toujours pas été trouvée, on l'ajoute en l'indiquant
                        self.listVar.store.append(None,( #ajout au stor calc
                                0,          # int # 0 # id de la ligne contenant le resultat (O : définit manuellement)
                                nameVar,    # str # 1 # nom de la variable (none si aucun nom)
                                0,          # flt # 2 # Valeur de la variable
                                0,          # int # 3 # Nombre de décimal
                                '',         # str # 4 # Unitée
                                _('Variable non trouvée !')))# str # 5 # Commentaires


        #listestoreVar → (varName,varValue) et suppression des enfants
        iter = self.listVar.store.get_iter_first()
        listVar = []
        while iter:
            if not self.listVar.store.iter_parent(iter) :
                listVar.append(self.listVar.store.get(iter,1,2,3))
            iter = self.listVar.store.iter_next(iter)

        self.traiter.new(entry,id,listVar)

        self.change_message('Résultat = %(valeur).3f %(unite)s'% {
                "valeur" : self.traiter.resultat(),
                "unite" :  self.traiter.get_unit()
            })



    def on_cmd_confirm(self,idCalc=False):
        '''Confirmation de la zone de saisie
        ajout ou edition du gtktree listcalc'''
        iterdebut,iterfin = self.cmd.buffer.get_bounds()
        entry = self.cmd.buffer.get_text(iterdebut,iterfin,True)
        #pdb.set_trace()

        if not idCalc:
            idCalc = int(self.idActu.get_text())

        listVar = []
        dicoVar = {}
        for (id,name,value,prec,unit,comm) in self.listVar.store:
            listVar.append((name,value,prec))
            dicoVar[name] = id

        self.traiter.new(entry,idCalc,listVar, True)

        aff = ( self.gui.get_widget('toggleAlgebre').get_active(),
                self.gui.get_widget('toggleNum').get_active(),
                0 #self.gui.get_widget('toggleLaTeX').get_active()
            )
        render = self.traiter.render(aff)

        #pdb.set_trace()
        precRes = self.precRes
        try :
            result = self.traiter.resultat()
        except :
            self.change_message(_('Erreur dans le saisie'),5)
        unit = self.traiter.get_unit()
        #listVar = self.traiter.listVar()
        #self.affRow(self.listVar)
        comm = self.traiter.get_commentaire()
        nameVar = self.traiter.get_nameVar()
        type = self.traiter.get_type()

        #~ self.oldentry_varname, self.oldentry_linkine
        if self.oldentry_varname != nameVar and len(self.oldentry_linkine) != 0 :
            '''Si l'ancienne entrée avait un nom de variable et des lignes liée afficherAvertissment'''
            self.change_message('Attention ligne liée')
            dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_INFO, # type
                    gtk.BUTTONS_YES_NO, # boutons
                    _("Un (ou plusieurs) autre calcul utilise le resultat de cette ligne. Si vous changez le nom de la variable ce calculs ne trouverra plus la valeur de ce résultat.\n\nSouhaitez-vous quand même modifier le nom de cette variable ?"))#Message

            if (dialog.run() != gtk.RESPONSE_YES):
                dialog.destroy()
                return True
            else :
                dialog.destroy()
        (self.oldentry_varname, self.oldentry_linkine) = ('',[])




        if self.positionInStore:
            '''édition d'une ligne'''
            iter = self.list.store.get_iter(self.positionInStore)
            old_row_store = self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10,11)#stockage de l'ancienne ligne pour ajout future dans tableau d'annulation
            id = self.idActu.get_text()
            #~ pdb.set_trace()
            id4actu = old_row_store[8] #Récupérer l'ancienne liste d'ID à actualisé
            row_store = (idCalc,nameVar,entry,render,aff,precRes,result,unit,id4actu,dicoVar,comm,type)
            self.debugType(row_store)
            self.list.store[self.positionInStore] = row_store
            self.positionInStore = None
            #~ self.idActu.set_text('')
            self.statusBar.pop(1)

            # Ajout de l'ancienne entreé dans le tableau d'annulation
            try :   idafter = self.list.store[self.positionInStore+1][0]
            except: idafter = None
            self.append_cancel(0, idafter, old_row_store)
            #~ self.cancel.append((0,idafter,self.idCalc,old_row_store)) # O indique que la ligne a été modifier
            #~ print "ajout annulation %s"%old_row_store[2]
        else:
            '''ajout d'une ligne'''
            print "ajouter dans l'arbre : %s"
#            print self.classTraiter.cdmConfirm(idCalc,cmd)
            #~ pdb.set_trace()
            row_store = (idCalc,nameVar,entry,render,aff,precRes,result,unit,[],dicoVar,comm,type) # LA YA UN TRUC PAS PROPRE DU TOUT car quand on cherche une variable le resultat un une chaine alors qu'il devrait etre un float
            self.debugType(row_store)
            iter = self.list.store.append(row_store)

            # Ajout de l'entreé dans le tableau s'annulation
            try :   idafter = self.liste.get_value(self.liste.iter_next(iter),0)
            except: idafter = None
            self.append_cancel(+1, idafter, self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10))
            #~ self.cancel.append((1, idafter, self.idCalc, self.list.store.get(iter,0,1,2,3,4,5,6,7,8,9,10))) # 1 indique que la ligne a été ajoutée

            # position la scrolledwindow en bas
            self.gui.get_widget('ListCalc').scroll_to_cell(self.list.store.get_path(iter)[0])

            #incrémentation de l'id
            self.idCalc += 1


        #Stocker les id des lignes qui doivent être actualisé lors de la
        #modification de cette ligne.
        self.id4maj(self.listVar.store,idCalc)

        #Actualiser les calculs liés
        #pdb.set_trace()
        self.majLinkCalc(self.list.store[iter][8],idCalc,idCalc)

        self.idActu.set_text('') #Supprime l'id
        self.listVar.store.clear() #Vide la treeview des variables
        self.listVar.tmp = []

        #Vider la zone de saisie cmd
        self.cmd.buffer.delete(iterdebut, iterfin)

        self.dicoIdLine4vars.clear() #vide le dico tmp des variables dispo

        #inscrit le dernier no de ligne
        self.idActu.set_text(str(self.idCalc))

        self.btSave_sensitive(True)


    def on_cmd_keypress_event(self, widget, event): #inspirer de chat_control.py de gajim ligne 250
        '''Signale de pression d'une touche sur de widget de ligne de commande'''
        print "on_cmd_keypress_event"

        #rendre la zone de commande éditable
        self.cmd.set_editable(True)

        # Touche entrer
        if event.keyval == gtk.keysyms.Return or event.keyval == gtk.keysyms.KP_Enter:
            if event.state == 0: # pas de ctrl, ni de shift just le toucher ENTER => confirmation de la saisisie
                print "validation de la commande"
                self.KEYentryOResc = True
                self.on_cmd_confirm()
                self.cmd.set_editable(False)
        # Touche escape => annulation
        elif event.keyval == gtk.keysyms.Escape:
            print "annulation"
            self.KEYentryOResc = True

            if self.cmd.buffer.get_char_count() == 0 :
                self.selection.unselect_all()
            else :
                self.cmdAnnule()
        #touche F5 => Actualisation manuelle
        #elif event.keyval == gtk.keysyms.F5:
        else:
            print event.keyval
            self.KEYentryOResc = False
            self.keyval = event.keyval
            #print "actualisation via F5"
            #self.on_cmd_actualise()



    def cmdAnnule(self):
        self.cmd.buffer.set_text('')
        self.idActu.set_text(str(self.idCalc))
        self.positionInStore = None
        self.statusBar.push(2,'Annulation de la saisie')

    def on_OKcmd_clicked(self,event):
        print 'validation de la commande via bouton valider'
        self.on_cmd_confirm()

    def on_KOcmd_clicked(self,event):
        print 'annulation de la commande via le bouton annuler'
        self.cmdAnnule()

    def on_cmd_buffer_changed(self,un):
        '''Quand le buffer de cmd change de contenu'''
        print '*** on_cmd_buffer_changed ***'
        #pdb.set_trace()
        if self.KEYentryOResc :
            'Si <Esc> ou <Enter> ont été enfoncé inutilise de (re)faire le traitement'
            pass
        elif self.keyval <  10000:
            'Si ni <Esc> ni <Enter> ont été enfoncé, actualisation de la commande'
            #Lever le drapeur qui indique qu'une ligne à été insérèe
            self.cmdCursor['insertLign'] = False
            #Actualise et affiche les variables
            self.on_cmd_actualise()



    ##############
    # - Autres - #
    ##############

        print 'on_ListCalc_expand_collapse_cursor_row'
    #Avertissment
    def afficherAvertissment(self,texte):
        self.gui.get_widget("labelAvertissement").set_text(texte)
        print 'afficherAvertissment'
        self.gui.get_widget("boxAvertissement").show()
    def on_fermerAvertissement_clicked(self,event):
        self.gui.get_widget("boxAvertissement").hide()


    def id4maj(self,storeVar,currentID):
        '''La ligne "courante" utilise des variables, il faut donc signaler aux lignes
        contenant ces variables que si elle sont modifiée il faut actualisé la ligne
        courante.'''
        for line in storeVar:
            idVar = line[0]
            if idVar == 0:
                '''id 0 signifie que cette variable n'existe pas, il n'y a
                donc aucune ligne a mettre a jour'''
            else :
                print '%s %s'%(idVar,type(idVar))
                iter = self.get_iterWithId(idVar)
                if not currentID in self.list.store[iter][8]:
                    self.list.store[iter][8].append(currentID)
                    print 'quand %s est modifier il faut actualisé %s'%(idVar,currentID)


    def majLinkCalc(self,listID,idActu='???',idDepart=None):
        '''Actualiser les lignes de calclul qui pépandent de celle que l'on
        vient de modifier (directement ou indiectement)
            * listID :      liste des id à actualisé
            * [idActu] :    chsais plus
            * [idDepart] :  id de départ (pour éviter des références circulaires)
        '''

        print '*** majLinkCalc() ***\nMise a jours des lignes liées à la ligne %s : %s'%(idActu, listID)
        for id in listID:
            print '*** MAJ id %s ****'%id
            if id == idDepart:
                '''Référence circulaire'''
                self.afficherAvertissment(_('Erreur de référence circulaire. La ligne de calcules %s dépand de la ligne actuelle')%idActu)
                return False
            else :
                print '     * maj line %s'%id
                #Rechercher l'iter de la ligne qui dépendes de la ligne modifier
                iter = self.get_iterWithId(id)

                self.majRow(iter)

                id4actu     = self.list.store[iter][8]
                self.majLinkCalc(id4actu,id,idDepart)
                self.positionInStore = None
        return True


    def majRow(self,iter):
        #Recalcul cette ligne
        print 'iter %s'%iter
        (id,nameVar,entry,aff,precRes,id4actu,dicoIdsVar,comm,type) = self.list.store.get(iter,0,1,2,4,5,8,9,10,11)
        #~ id          = self.list.store[iter][0]
        #~ entry       = self.list.store[iter][2]
        print '         %s : %s '%(id,entry)
        #~ dicoIdsVar  = self.list.store[iter][9]
        listVar = []
        #~ pdb.set_trace()
        for (name,idsVar) in dicoIdsVar.items():
            #~ print idsVar
            #~ pdb.set_trace()
            if idsVar != 0 :
                listVar.append((
                        name,       # str # 0 # nom de la variable
                        self.list.store[self.get_iterWithId(idsVar)][6],
                        self.list.store[self.get_iterWithId(idsVar)][5],
                    ))
            else :
                listVar.append((
                        name,       # str # 0 # nom de la variable
                        0,
                        0,
                    ))
        #~ pdb.set_trace()
        self.traiter.new(entry,id,listVar,True)
        #~ nameVar = self.list.store[iter][1]
        #~ aff         = self.list.store[iter][4]
        render  = self.traiter.render(aff)
        #~ precRes     = self.list.store[iter][5]
        result  = self.traiter.resultat()
        unit    = self.traiter.get_unit()
        #~ id4actu     = self.list.store[iter][8]
        #~ comm        = self.list.store[iter][10]
        #~ type        = self.list.store[iter][11]


        #Affiche la ligne
        row_store = (id,nameVar,entry,render,aff,precRes,result,unit,id4actu,dicoIdsVar,comm,type)
        self.list.store[iter] = row_store

        return True


    def get_iterWithId(self,id) :
        ''' Parcour la liste des caluculs pour trouver l'iter de l'id'''
        path = 0
        for linestore in self.list.store:
            if linestore[0] == id :
                return self.list.store.get_iter(path)
                break
            path += 1





    ### Signaux dans le MenuClickdroit de ListedeCalc ##########################
    #Editer
    def on_Editer_BtDroit_activate(self,event):
        print 'Editer bouton droit : %s' %event

    def affRow(self,row):
        '''Fonction d'aide au developpement Affichant le contenu d'une ligne
        d'un liststore'''
        i = 0
        text = ''
        print 'start row : %s -----'%row
        for cell in row:
            text += 'Cell %s : %s | '%(i,cell)
            i += 1
        print text
        print 'end row -----'

    def debugType(self,array):
        '''Afficher les types des élement d'une liste, dico, tableau ...
        * array :   Tableau quelquonc'''
        i = 0
        for item in array:
            print "clef : %s |  type %s | valeur : %s"%(i, type(item), str(item))
            i += 1




# ******************************************************************************
# Treeview ListeDeCalc
class TreeViewListCalc(object): #object:arbre gtk

    #Modèle
    def modelID(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 0)
        cell.set_property('text', str)
        cell.set_property('width', 28)
        cell.set_property("cell-background-gdk",self.default_style.bg[gtk.STATE_INSENSITIVE])
        return

    def modelNameVar(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 1)
        cell.set_property('text', str)
        return

    def modelCalc(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 3)
        if model.get_value(iter, 11) == 'img':
            cell.set_property('visible', False)
        else :
            cell.set_property('yalign',0)
            #~ pdb.set_trace()
            if model.get_value(iter, 11) == 'h1':
                cell.set_property('xpad', 0)
            elif model.get_value(iter, 11) == 'h2':
                cell.set_property('xpad', 10)
            elif model.get_value(iter, 11) == 'h3':
                cell.set_property('xpad', 20)
            elif model.get_value(iter, 11) == 'h4':
                cell.set_property('xpad', 30)
            elif model.get_value(iter, 11) == 'h5':
                cell.set_property('xpad', 40)
            elif model.get_value(iter, 11) == 'h6':
                cell.set_property('xpad', 40)
            else :
                cell.set_property('xpad', 40)

            cell.set_property('width',120)
            cell.set_property('ellipsize',pango.ELLIPSIZE_END)
            cell.set_property('markup', str)
            cell.set_property('visible', True)

            # FIXME : les infobulle ne marche pas :(
            #~ tooltip =  gtk.Tooltip()
            #~ tooltip.set_markup(str)
            #~ self.list.set_tooltip_cell(tooltip,None,tvcolumn,cell)
        return

    def modelImage(self, tvcolumn, cell, model, iter):
        if model.get_value(iter, 11) == 'img':
            #affiche l'image
            pb = model.get_value(iter, 4)['pixbuf']
            try : cell.set_property('pixbuf', pb)
            except : pdb.set_trace()
            cell.set_property('visible', True)
            cell.set_property('xpad', 40)
        else:
            cell.set_property('pixbuf', None)
            cell.set_property('visible', False)
            self.comment_img=None

    def modelResult(self, tvcolumn, cell, model, iter):
        #print "resultat = %s" %str
        #~ pdb.set_trace()
        if  ( not model.get_value(iter, 11) in ('calc','calcvar') ) :
            '''n'a pas de calucl, masque la cellule'''
            cell.set_property('visible', False)
        else:
            res =  model.get_value(iter, 6)
            prec = model.get_value(iter, 5)

            import traiter
            if (model.get_value(iter, 7) == ''):
                #~ str4print = '= %%.%if'%prec
                str4print = '= %s'%traiter.str4printRoundRes(prec)
            else:
                #~ str4print = '= %%.%if [<i>%s</i>]'%(prec, model.get_value(iter, 7))
                str4print = '= %s [<i>%s</i>]'%(traiter.str4printRoundRes(prec), model.get_value(iter, 7))
            cell.set_property('visible', True)
            cell.set_property('markup', str4print%res)
            cell.set_property('yalign',1)

            #~ cell.set_property('background-gdk',self.default_style.light[gtk.STATE_NORMAL])

            #~ cell.set_property('foreground-gdk',cell.get_property('background-gdk'))
            #~ cell.set_property('foreground-set
        return


    def linkLine(self, tvcolumn, cell, model, iter):
        #~ str = ', '.join(model.get_value(iter, 7))
        str = model.get_value(iter, 8)
        cell.set_property('text', str)
        return

    def modelComm(self, tvcolumn, cell, model, iter):
        #~ if self.comment_img :   str = self.comment_img
        #~ else:                   str = model.get_value(iter, 10)
        str = model.get_value(iter, 10)
        cell.set_property('text', str)
        cell.set_property('yalign',0)
        return

    def modelDebug(self, tvcolumn, cell, model, iter):
        '''Information pour debug'''
        print "%s"% model.get_value(iter, 1)
        str =  "Nom de la variable : %(nameVar)s\
                \nentry : %(entry)s\
                \nLigne à mettre à jour : %(majLine)s\
                \nId des variable du calc : %(id4var)s\
                \nrender : %(render)s\
                \ntype : %(type)s'"%{
                    'nameVar'   :   model.get_value(iter, 1),
                    'entry'     :   model.get_value(iter, 2),
                    'render'    :   model.get_value(iter, 4),
                    'majLine'   :   model.get_value(iter, 8),
                    'id4var'    :   model.get_value(iter, 9),
                    'type'      :   model.get_value(iter, 11)
                    }
        cell.set_property('text', str)

    #Edition de la cellule
    def edited_cb(self, cell, path, new_text, treeview):
        'Edition de cellule'
        print "path: %s, treeview: %s" % (path,treeview)

        #~ global DicoCalculs

        print 'edition de la cellule %s' %treeview[path][0]

        #~ global id, BDD

        import traiter
        traite = traiter.traiter()
        import variable
        variable = variable.variable()

        if treeview[path][0] == str(id):
            id=id+1
            print "id = %s" % id
            #treeview[path][0] = id
            main.list.store.append([id,'',''])
            idActu = id
        else:
            idActu = treeview[path][0]

        print "Change '%s' to '%s'" % (treeview[path][1], new_text)

        #treeview[path][1] = traite.render(new_text)
        FormArithm = traite.render(new_text)
        FormNum = variable.find(new_text)
        treeview[path][2] = FormArithm + '\n' + FormNum
        print type(new_text)

        treeview[path][4] = '-'

        resultat = str(traite.start(treeview[path][4]))
        print 'calculer(new_text) : %s' % resultat
        treeview[path][3] = resultat
        text_formater = new_text

        BDD[str(id)] = [id, new_text, text_formater, resultat, path]


        #print "resultat : %s" % calculer(new_text)
        return


    def __init__(self, treeview):
        # Configure the view
        self.list = treeview

        # Create the backend store
        self.store = gtk.ListStore(
                int,    # 0 # id
                str,    # 1 # nom de la variable
                str,    # 2 # entrée de l'utilisateur
                str,    # 3 # chaine rendu
                object, # 4 # affichage
                int,    # 5 # précision de l'affichage du resultat
                float,  # 6 # Résultat
                str,    # 7 # unitée
                object, # 8 # Liste de ligne liée
                object, # 9 # Dico des ids des variables nécéssaire au calculs
                str,    #10 # commentaire
                str     #11 # type de l'entrée (empty,calc,var,calcvar,h1,h2,h3,h4,h5,h6,img,txt)
            )

        self.default_style = self.list.get_style()
        #~ self.colorinactive = self.default_style.bg[gtk.STATE_INSENSITIVE]
        #~ self.colorinactive.red = (self.colorinactive.red + (self.default_style.white).red) /2
        #~ self.colorinactive.green = (self.colorinactive.green + (self.default_style.white).green) /2
        #~ self.colorinactive.blue = (self.colorinactive.blue + (self.default_style.white).blue) /2


        cellID = gtk.CellRendererText()
        cellcalc = gtk.CellRendererText()
        cellImage = gtk.CellRendererPixbuf()
        cellresult = gtk.CellRendererText()
        #~ cellUnit = gtk.CellRendererText()
        cellComm = gtk.CellRendererText()
        if ncalc_cst.debug : cellDebug = gtk.CellRendererText()


        self.colID   = gtk.TreeViewColumn('#')
        self.colCalc = gtk.TreeViewColumn(_('Calculs'))
        self.colCalc.set_resizable(True)
        #~ self.colRes  = gtk.TreeViewColumn(_('Résultats'))
        #~ self.colRes.set_resizable(True)
        self.colComment = gtk.TreeViewColumn(_('Comment'))
        self.colComment.set_resizable(True)
        if ncalc_cst.debug : self.colDebug = gtk.TreeViewColumn('Debug')


        self.list.append_column(self.colID)
        self.list.append_column(self.colCalc)
        #~ self.list.append_column(self.colRes)
        self.list.append_column(self.colComment)
        if ncalc_cst.debug : self.list.append_column(self.colDebug)


        # Pack CellRenderers
        self.colID.pack_start(cellID, False)
        self.colCalc.pack_start(cellImage, False)
        self.colCalc.pack_start(cellcalc, True)

        #~ self.colRes.pack_start(cellresult, False)
        self.colCalc.pack_end(cellresult, False)

        self.colComment.pack_start(cellComm, False)
        if ncalc_cst.debug : self.colDebug.pack_start(cellDebug, False)

        self.colID.set_cell_data_func(cellID, self.modelID)
        self.colCalc.set_cell_data_func(cellcalc, self.modelCalc)
        self.colCalc.set_cell_data_func(cellImage,self.modelImage)
        #~ self.colRes.set_cell_data_func(cellresult, self.modelResult)
        self.colCalc.set_cell_data_func(cellresult, self.modelResult)
        self.colComment.set_cell_data_func(cellComm, self.modelComm)
        if ncalc_cst.debug : self.colDebug.set_cell_data_func(cellDebug, self.modelDebug)

        # Connect the view to the backend
        self.list.set_model(self.store)
        return


    def loadDico(self, dico):
        "Fonction qui inscrit le contenu du dico dans le gtktree"

        id = 0
        while id in dico:
            main.list.store.append(id,dico[i]['calcFormat'],dico[i]['res'])
            id = id + 1

# ******************************************************************************
# Treeview ListeDeVar
class TreeViewListVar(object): #object:arbre gtk
    def modelName(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 1)
        cell.set_property('text', str)
        #IDcalc = int(IDcalc) + 1
        return
    def modelEgale(self, tvcolumn, cell, model, iter):
        cell.set_property('text', '=')
        return
    def modelValue(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 2)
        import traiter
        cell.set_property('text', traiter.str4printRoundRes(model.get_value(iter, 3))%str)
        return
    def modelUnit(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 4)
        if str:
            str = str.join(('[',']'))
        cell.set_property('text', str)
        return

    def modelCommentaire(self, tvcolumn, cell, model, iter):
        str = model.get_value(iter, 5)
        cell.set_property('text', str)
        if model.get_value(iter, 0) == 0 :
            cell.set_property('background', 'pink')
        else :
            cell.set_property('background', None)
        return

    def __init__(self, treeview):
        #global store #sais plus a koi ca sert

        # Configure the view
        self.list = treeview

        # Create the backend store
        self.store = gtk.TreeStore(
            int,    # 0 # id de la ligne contenant le resultat (O : non trouvé)
            str,    # 1 # nom de la variable (none si aucun nom)
            float,  # 2 # Valeur de la variable
            int,    # 3 # Nombre de décimale
            str,    # 4 # Unitée
            str)    # 5 # Commentaires

        cellName = gtk.CellRendererText()
        cellEgale = gtk.CellRendererText()
        cellValue = gtk.CellRendererText()
        cellUnit = gtk.CellRendererText()
        cellCommentaire = gtk.CellRendererText()

        self.variableColumn = gtk.TreeViewColumn('Variable')
        self.commentColumn  = gtk.TreeViewColumn('Commentaire')
        self.list.append_column(self.variableColumn)
        self.list.append_column(self.commentColumn)

        # Pack CellRenderers
        self.variableColumn.pack_start(cellName, True)
        self.variableColumn.pack_start(cellEgale, True)
        self.variableColumn.pack_start(cellValue, True)
        self.variableColumn.pack_start(cellUnit, True)
        self.commentColumn.pack_start(cellCommentaire, True)

        self.variableColumn.set_cell_data_func(cellName, self.modelName)
        self.variableColumn.set_cell_data_func(cellEgale, self.modelEgale)
        self.variableColumn.set_cell_data_func(cellValue, self.modelValue)
        self.variableColumn.set_cell_data_func(cellUnit, self.modelUnit)
        self.commentColumn.set_cell_data_func(cellCommentaire, self.modelCommentaire)


        # Connect the view to the backend
        self.list.set_model(self.store)
        return




#Démarrage de l'interface graphique
main = gui()
#~ gtk.gdk.threads_init()
#~ gtk.gdk.threads_enter()
gtk.main()
#~ gtk.gdk.threads_leave()
